% This code calculates dispersion of a photonic crystal waveguide [1]. The
% waveguide properties is set in the function "SquareLattice".
% [1] N. Habibi, A. Khavasi, and K. Mehrany, "Circuit Model for Mode
% Extraction in Lossy/Lossless Photonic Crystal Waveguides," J. Opt. Soc. 
% Am. B., vol. 29, no. 1, pp. 170-177, Jan. 2012.
betaPCW = linspace(0,2.2,40);
fun = fcnchk(@SquareLattice);
wvec = 0;
tol = 1e-4;
fcal = 15;
N = 3;
wmin = 0.29;
wmax = 0.43;
for jj = 1:length(betaPCW)
    beta = betaPCW(jj);
   [wnout Exts] = ModeFindTL(fun,beta,wmin,wmax,fcal,N,tol);
for kk =1:length(wnout(1,:))
    if wnout(kk)~=0
        wvec(jj,kk) = wnout(kk);
    end
end

end
clear Exts N ans beta fcal fun jj kk tol wmax wmin wnout

