function [wnout, Exts] = ModeFindTL(ffcn,beta,wstart,wend,fcal,N,tol)
f = fcnchk(ffcn);
wvec = linspace(wstart,wend,fcal);
output = wvec;
Ref = wvec;
Exts = 0;
for j = 1 : fcal
    [output(j) Ref(j)] = f(wvec(j),beta,N);
end
diffImp = diff(abs(output));
Signdiff = diffImp(1:fcal-2).*diffImp(2:fcal-1);
for j = 1 : fcal-2
    if Signdiff(j) < 0
        if diffImp(j)<0

            Exts = Exts + 1;
            wnout(1,Exts) = wvec(j);
            wnout(2,Exts) = wvec(j+2);            
        end
    end
end

for j = 1:Exts
    wnout(3,j) = fminbnd(@(w) f(w,beta,N),wnout(1,j),wnout(2,j),optimset('TolX',tol));
    fwu = f(wnout(3,j)+0.005,beta,N);
    fwd = f(wnout(3,j)-0.005,beta,N);
    fw = f(wnout(3,j),beta,N);
    Qw = min(fwu,fwd)/fw;
    if Qw<20
        wnout(3,j) = NaN;
    end
end
wnout=wnout(3,:);
